﻿-- Author      : Sidrus
-- Create Date : 7/3/2009 5:08:52 PM

function LODBConverter_FromAlpha(db)
    -- v0.1-beta introduced account names that are all lower case.
    local tmpDb = {};
    
    for k,v in pairs(db.factionrealm) do
        tmpDb[string.lower(k)] = v;
    end
    setmetatable(tmpDb, getmetatable(db.factionrealm));
    
    -- save the updated database
    db:ResetDB("Default");
    for key,value in pairs(tmpDb) do
        db.factionrealm[key] = value;
    end
    
    -- mark this with the current version tag
    db.factionrealm.version = "0.1-beta";
    
    -- call the next converter in the chain
    LODBConverter_From01Beta(db);
end
function LODBConverter_From01Beta(db)
end

LODBConverter = {
    ["currentVersion"] = "0.1-beta",
    ["converters"] = {
        ["0.1-alpha"] = LODBConverter_FromAlpha,
        ["0.1-beta"]  = LODBConverter_From01Beta
    }
};
function LODBConverter:UpgradeDatabase(db)
    local version = db.factionrealm.version or "0.1-alpha";
    
    -- need to do some checking here to make sure 
    -- we have a converter for the specified version.
    -- If one does not exist, then need to fail and 
    -- alert the user.    
    LODBConverter.converters[version](db);
end
function LODBConverter:IsCurrentVersion(version)
    return (version == self.currentVersion);
end
function LODBConverter:GetCurrentVersion()
    return self.currentVersion;
end